﻿Imports System.IO
Imports System.Data
Imports System.Data.SqlClient
Public Class Form1
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Set AutoGenerateColumns False.
        dataGridView1.AutoGenerateColumns = False

        'Set Columns Count.
        dataGridView1.ColumnCount = 2

        'Add Columns.
        dataGridView1.Columns(0).Name = "Id"
        dataGridView1.Columns(0).HeaderText = "Image Id"
        dataGridView1.Columns(0).DataPropertyName = "Id"

        dataGridView1.Columns(1).HeaderText = "Name"
        dataGridView1.Columns(1).Name = "Name"
        dataGridView1.Columns(1).DataPropertyName = "Name"

        'Add a Image Column to the DataGridView at the third position.
        Dim imageColumn As DataGridViewImageColumn = New DataGridViewImageColumn()
        imageColumn.Name = "Data"
        imageColumn.DataPropertyName = "Data"
        imageColumn.HeaderText = "Image"
        imageColumn.ImageLayout = DataGridViewImageCellLayout.Stretch
        dataGridView1.Columns.Insert(2, imageColumn)
        dataGridView1.RowTemplate.Height = 100
        dataGridView1.Columns(2).Width = 100

        'Bind DataGridView.
        Me.BindDataGridView()
    End Sub

    Private Sub BindDataGridView()
        Dim constr As String = "Data Source=.\SQL2014;Initial Catalog=dbFiles;Integrated Security=true"
        Using conn As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter("SELECT * FROM tblFiles", conn)
                Dim dt As DataTable = New DataTable()
                sda.Fill(dt)
                dataGridView1.DataSource = dt
            End Using
        End Using
    End Sub

    Private Sub btnChoose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnChoose.Click
        Using openFileDialog1 As OpenFileDialog = New OpenFileDialog()
            If openFileDialog1.ShowDialog() = DialogResult.OK Then
                Dim fileName As String = openFileDialog1.FileName
                Dim bytes As Byte() = File.ReadAllBytes(fileName)
                Dim contentType As String = ""
                Select Case Path.GetExtension(fileName)
                    Case ".jpg"
                        contentType = "image/jpeg"
                    Case ".png"
                        contentType = "image/png"
                    Case ".gif"
                        contentType = "image/gif"
                    Case ".bmp"
                        contentType = "image/bmp"
                End Select

                Dim constr As String = "Data Source=.\SQL2014;Initial Catalog=dbFiles;Integrated Security=true"
                Using conn As SqlConnection = New SqlConnection(constr)
                    Dim sql As String = "INSERT INTO tblFiles VALUES(@Name, @ContentType, @Data)"
                    Using cmd As SqlCommand = New SqlCommand(sql, conn)
                        cmd.Parameters.AddWithValue("@Name", Path.GetFileName(fileName))
                        cmd.Parameters.AddWithValue("@ContentType", contentType)
                        cmd.Parameters.AddWithValue("@Data", bytes)
                        conn.Open()
                        cmd.ExecuteNonQuery()
                        conn.Close()
                    End Using
                End Using

                Me.BindDataGridView()
            End If
        End Using
    End Sub
End Class
